/* Autogenerated file. Do not edit manually. */
/* tslint:disable */
/* eslint-disable */

import {
  ethers,
  EventFilter,
  Signer,
  BigNumber,
  BigNumberish,
  PopulatedTransaction,
  BaseContract,
  ContractTransaction,
  Overrides,
  CallOverrides,
} from "ethers";
import { BytesLike } from "@ethersproject/bytes";
import { Listener, Provider } from "@ethersproject/providers";
import { FunctionFragment, EventFragment, Result } from "@ethersproject/abi";
import type { TypedEventFilter, TypedEvent, TypedListener } from "./common";

interface ClaimsRevocationRegistryInterface extends ethers.utils.Interface {
  functions: {
    "revokeClaim(bytes32,address,address)": FunctionFragment;
    "revokeClaimsInList(bytes32,address[],address)": FunctionFragment;
    "isRevoked(bytes32,address)": FunctionFragment;
    "getRevocationDetail(bytes32,address)": FunctionFragment;
  };

  encodeFunctionData(
    functionFragment: "revokeClaim",
    values: [BytesLike, string, string]
  ): string;
  encodeFunctionData(
    functionFragment: "revokeClaimsInList",
    values: [BytesLike, string[], string]
  ): string;
  encodeFunctionData(
    functionFragment: "isRevoked",
    values: [BytesLike, string]
  ): string;
  encodeFunctionData(
    functionFragment: "getRevocationDetail",
    values: [BytesLike, string]
  ): string;

  decodeFunctionResult(
    functionFragment: "revokeClaim",
    data: BytesLike
  ): Result;
  decodeFunctionResult(
    functionFragment: "revokeClaimsInList",
    data: BytesLike
  ): Result;
  decodeFunctionResult(functionFragment: "isRevoked", data: BytesLike): Result;
  decodeFunctionResult(
    functionFragment: "getRevocationDetail",
    data: BytesLike
  ): Result;

  events: {
    "Revoked(bytes32,address,address)": EventFragment;
  };

  getEvent(nameOrSignatureOrTopic: "Revoked"): EventFragment;
}

export type RevokedEvent = TypedEvent<
  [string, string, string] & { role: string; subject: string; revoker: string }
>;

export class ClaimsRevocationRegistry extends BaseContract {
  connect(signerOrProvider: Signer | Provider | string): this;
  attach(addressOrName: string): this;
  deployed(): Promise<this>;

  listeners<EventArgsArray extends Array<any>, EventArgsObject>(
    eventFilter?: TypedEventFilter<EventArgsArray, EventArgsObject>
  ): Array<TypedListener<EventArgsArray, EventArgsObject>>;
  off<EventArgsArray extends Array<any>, EventArgsObject>(
    eventFilter: TypedEventFilter<EventArgsArray, EventArgsObject>,
    listener: TypedListener<EventArgsArray, EventArgsObject>
  ): this;
  on<EventArgsArray extends Array<any>, EventArgsObject>(
    eventFilter: TypedEventFilter<EventArgsArray, EventArgsObject>,
    listener: TypedListener<EventArgsArray, EventArgsObject>
  ): this;
  once<EventArgsArray extends Array<any>, EventArgsObject>(
    eventFilter: TypedEventFilter<EventArgsArray, EventArgsObject>,
    listener: TypedListener<EventArgsArray, EventArgsObject>
  ): this;
  removeListener<EventArgsArray extends Array<any>, EventArgsObject>(
    eventFilter: TypedEventFilter<EventArgsArray, EventArgsObject>,
    listener: TypedListener<EventArgsArray, EventArgsObject>
  ): this;
  removeAllListeners<EventArgsArray extends Array<any>, EventArgsObject>(
    eventFilter: TypedEventFilter<EventArgsArray, EventArgsObject>
  ): this;

  listeners(eventName?: string): Array<Listener>;
  off(eventName: string, listener: Listener): this;
  on(eventName: string, listener: Listener): this;
  once(eventName: string, listener: Listener): this;
  removeListener(eventName: string, listener: Listener): this;
  removeAllListeners(eventName?: string): this;

  queryFilter<EventArgsArray extends Array<any>, EventArgsObject>(
    event: TypedEventFilter<EventArgsArray, EventArgsObject>,
    fromBlockOrBlockhash?: string | number | undefined,
    toBlock?: string | number | undefined
  ): Promise<Array<TypedEvent<EventArgsArray & EventArgsObject>>>;

  interface: ClaimsRevocationRegistryInterface;

  functions: {
    revokeClaim(
      role: BytesLike,
      subject: string,
      revoker: string,
      overrides?: Overrides & { from?: string | Promise<string> }
    ): Promise<ContractTransaction>;

    revokeClaimsInList(
      role: BytesLike,
      subjects: string[],
      revoker: string,
      overrides?: Overrides & { from?: string | Promise<string> }
    ): Promise<ContractTransaction>;

    isRevoked(
      role: BytesLike,
      subject: string,
      overrides?: CallOverrides
    ): Promise<[boolean]>;

    getRevocationDetail(
      role: BytesLike,
      subject: string,
      overrides?: CallOverrides
    ): Promise<[string, BigNumber]>;
  };

  revokeClaim(
    role: BytesLike,
    subject: string,
    revoker: string,
    overrides?: Overrides & { from?: string | Promise<string> }
  ): Promise<ContractTransaction>;

  revokeClaimsInList(
    role: BytesLike,
    subjects: string[],
    revoker: string,
    overrides?: Overrides & { from?: string | Promise<string> }
  ): Promise<ContractTransaction>;

  isRevoked(
    role: BytesLike,
    subject: string,
    overrides?: CallOverrides
  ): Promise<boolean>;

  getRevocationDetail(
    role: BytesLike,
    subject: string,
    overrides?: CallOverrides
  ): Promise<[string, BigNumber]>;

  callStatic: {
    revokeClaim(
      role: BytesLike,
      subject: string,
      revoker: string,
      overrides?: CallOverrides
    ): Promise<void>;

    revokeClaimsInList(
      role: BytesLike,
      subjects: string[],
      revoker: string,
      overrides?: CallOverrides
    ): Promise<void>;

    isRevoked(
      role: BytesLike,
      subject: string,
      overrides?: CallOverrides
    ): Promise<boolean>;

    getRevocationDetail(
      role: BytesLike,
      subject: string,
      overrides?: CallOverrides
    ): Promise<[string, BigNumber]>;
  };

  filters: {
    "Revoked(bytes32,address,address)"(
      role?: BytesLike | null,
      subject?: string | null,
      revoker?: string | null
    ): TypedEventFilter<
      [string, string, string],
      { role: string; subject: string; revoker: string }
    >;

    Revoked(
      role?: BytesLike | null,
      subject?: string | null,
      revoker?: string | null
    ): TypedEventFilter<
      [string, string, string],
      { role: string; subject: string; revoker: string }
    >;
  };

  estimateGas: {
    revokeClaim(
      role: BytesLike,
      subject: string,
      revoker: string,
      overrides?: Overrides & { from?: string | Promise<string> }
    ): Promise<BigNumber>;

    revokeClaimsInList(
      role: BytesLike,
      subjects: string[],
      revoker: string,
      overrides?: Overrides & { from?: string | Promise<string> }
    ): Promise<BigNumber>;

    isRevoked(
      role: BytesLike,
      subject: string,
      overrides?: CallOverrides
    ): Promise<BigNumber>;

    getRevocationDetail(
      role: BytesLike,
      subject: string,
      overrides?: CallOverrides
    ): Promise<BigNumber>;
  };

  populateTransaction: {
    revokeClaim(
      role: BytesLike,
      subject: string,
      revoker: string,
      overrides?: Overrides & { from?: string | Promise<string> }
    ): Promise<PopulatedTransaction>;

    revokeClaimsInList(
      role: BytesLike,
      subjects: string[],
      revoker: string,
      overrides?: Overrides & { from?: string | Promise<string> }
    ): Promise<PopulatedTransaction>;

    isRevoked(
      role: BytesLike,
      subject: string,
      overrides?: CallOverrides
    ): Promise<PopulatedTransaction>;

    getRevocationDetail(
      role: BytesLike,
      subject: string,
      overrides?: CallOverrides
    ): Promise<PopulatedTransaction>;
  };
}
