import { AxiosInstance, AxiosResponse } from 'axios';
import { SignerService } from '../signer';
import { AuthTokens } from './cache-client.types';
/**
 * Provides authentication methods to ssi-hub
 *
 * @todo Move here authentication parts of `CacheClient`
 * @todo Make this class top-level module in order to use in application
 */
export declare class SsiAuth {
    private signerService;
    private http;
    private readonly config;
    constructor(signerService: SignerService, http: AxiosInstance);
    /**
     * Signs in to ssi-hub. Authentication method configurations are looked for in `cacheConfigs`
     *
     * @returns authentication tokens
     */
    signIn(): Promise<AxiosResponse<AuthTokens>>;
}
